//-----------------------------------------------------------------------------
// Torque Game Engine
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

// Channel assignments (channel 0 is unused in-game).

$GuiAudioType     = 1;
$SimAudioType     = 2;
$MessageAudioType = 3;

new AudioDescription(AudioGui)
{
   volume   = 1.0;
   isLooping= false;
   is3D     = false;
   type     = $GuiAudioType;
};

new AudioDescription(AudioMessage)
{
   volume   = 1.0;
   isLooping= false;
   is3D     = false;
   type     = $MessageAudioType;
};

// Used for Looping Environmental Sounds
datablock AudioDescription(AudioLooping2D)
{
   volume = 10.0;
   isLooping = true;
   is3D = false;
   type = $SimAudioType;
};

datablock AudioProfile(BgMusic)
{
	filename="~/data/sound/bgMusic.ogg";
	description="AudioLooping2D";
	preload=false;
};


datablock AudioDescription(collision)
{
   volume = 10.0;
   isLooping = false;
   is3D = false;
   type = $SimAudioType;
};

datablock AudioProfile(keyCollision)
{
	filename="~/data/sound/oneUp.ogg";
	description="collision";
	preload=false;
};

datablock AudioProfile(coinCollision)
{
	filename="~/data/sound/key.ogg";
	description="collision";
	preload=false;
};

datablock AudioProfile( RocketExplosionSound )
{
	filename = "~/data/sound/rocket_explosion.ogg";
	description = "collision";
	preload = false;
};


/*
datablock AudioProfile(Rocco)
{
	filename="~/data/sound/boss.ogg";
	description="collision";
	preload=false;
};
*/
