//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

datablock ItemData(Coin)//StaticShapeData(Coin)
{
   category = "Items";
   shapeFile = "~/data/shapes/items/coin.dts";
   sticky = true;
   lightColor = "1 1 1 1.0";
   lightRadius = 5.0;
   lightType = "PulsingLight";
   mass = 1.0;
   respawn = false;
};

function ItemData::create( %data )
{
	echo( "ItemData::create for Coin called --------------------------" );

	%obj = new Item()
	{
		dataBlock = %data;
		rotate = true; // All items will rotate.
		static = true; // items should stay put so they don't slide away.
	};

	return %obj;
}

function Coin::onCollision(%this, %obj, %col)
{
 // collision function for all Torque logo shapes
 // %this  data block
 // %obj  - object itself
 // %col  - object that collided with %obj
// check for logo collision with player object
if(%col.getClassName() $= "Player")
 {
   // %client becomes client whose player hit logo 
   %client = %col.client;
   alxPlay(coinCollision);
   // remove object from logos
   %obj.delete();

  %client.HP = %client.HP - 5;
  commandToClient(%client, 'SetHPCounter', %client.HP);
 }
}
