//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
//  Server and mission initialization
//-----------------------------------------------------------------------------

function onServerCreated()
{
   // This function is called when a server is constructed.

   // Master server information for multiplayer games
   $Server::GameType = "Torque TTB";
   $Server::MissionType = "None";

   // Load up all datablocks, objects etc.
   exec("./rocket_launcher.cs");
   exec("./camera.cs");
   exec("./editor.cs");
   exec("./player.cs");
   exec("./bot.cs");
   exec("./fullkey.cs");
   exec("./prisonwall.cs");
   exec("./swarmbot.cs");
   exec("./jefferson.cs");
   exec("./jeffersontriggers.cs");
   exec("./door.cs");
   exec("./coin.cs");
   exec("./wintrigger.cs");
   exec("./harold.cs");
   exec("./guntrigger.cs");
   exec("./audioProfiles.cs"); 
	error("audio loaded");
   exec("common/server/lightingSystem.cs");
}

function onServerDestroyed()
{
   // This function is called as part of a server shutdown.
}


//-----------------------------------------------------------------------------

function onMissionLoaded()
{
   // Called by loadMission() once the mission is finished loading.
   new ScriptObject(AIManager){};
   MissionCleanup.add(AIManager);
   AIManager.think();
   %score=10;
   %HP =0;
   ScoreCounter.setText("Keys Left:" SPC %score);
   HPCounter.setText("Money : 100");
   InitSwarm();
   InitJeffersonNPC();
   alxPlay(BgMusic);

	%bot = AIPlayer::spawnOnPath( "Bot_1", "MissionGroup/bot1path" );
	%bot.followPath( "MissionGroup/bot1path", -1 );

	%bot2 = AIPlayer::spawnOnPath( "Bot_2", "MissionGroup/bot2path" );
	%bot2.followPath( "MissionGroup/bot2path", -1 );

	%bot3 = AIPlayer::spawnOnPath( "Bot_3", "MissionGroup/bot3path" );
	%bot3.followPath( "MissionGroup/bot3path", -1 );

	%bot4 = AIPlayer::spawnOnPath( "Bot_4", "MissionGroup/bot4path" );
	%bot4.followPath( "MissionGroup/bot4path", -1 );

	%bot5 = AIPlayer::spawnOnPath( "Bot_5", "MissionGroup/bot5path" );
	%bot5.followPath( "MissionGroup/bot5path", -1 );

	%bot6 = AIPlayer::spawnOnPath( "Bot_6", "MissionGroup/bot6path" );
	%bot6.followPath( "MissionGroup/bot6path", -1 );

	%bot7 = AIPlayer::spawnOnPath( "Bot_7", "MissionGroup/bot7path" );
	%bot7.followPath( "MissionGroup/bot7path", -1 );

	%bot8 = AIPlayer::spawnOnPath( "Bot_8", "MissionGroup/bot8path" );
	%bot8.followPath( "MissionGroup/bot8path", -1 );

	%bot9 = AIPlayer::spawnOnPath( "Bot_9", "MissionGroup/bot9path" );
	%bot9.followPath( "MissionGroup/bot9path", -1 );
	
	%bot10 = AIPlayer::spawnOnPath( "Bot_10", "MissionGroup/bot10path" );
	%bot10.followPath( "MissionGroup/bot10path", -1 );
}

function onMissionEnded()
{
   // Called by endMission(), right before the mission is destroyed
   alxStopAll();
   AIManager.delete();

}


//-----------------------------------------------------------------------------
// Dealing with client connections
// These methods are extensions to the GameConnection class. Extending
// GameConnection make is easier to deal with some of this functionality,
// but these could also be implemented as stand-alone functions.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

function GameConnection::onClientEnterGame(%this)
{
   // Every client get's a camera object.
   %this.camera = new Camera() {
      dataBlock = Observer;
   };
   MissionCleanup.add( %this.camera );
   %this.camera.scopeToClient(%this);

   // Create a player object.
   %spawnPoint = pickSpawnPoint();
   %this.createPlayer(%spawnPoint);
}

function GameConnection::onClientLeaveGame(%this)
{
   if (isObject(%this.camera))
      %this.camera.delete();
   if (isObject(%this.player))
      %this.player.delete();
}


//-----------------------------------------------------------------------------

function GameConnection::createPlayer(%this, %spawnPoint)
{
   if (%this.player > 0)  {
      // The client should not have a player currently
      // assigned.  Assigning a new one could result in 
      // a player ghost.
      error( "Attempting to create an angus ghost!" );
   }

   // Create the player object
   %player = new Player() {
      dataBlock = PlayerBody;
      client = %this;
   };
   MissionCleanup.add(%player);

   // Player setup...
   %player.setTransform(%spawnPoint);
   %player.setShapeName(%this.name);
   
   // Update the camera to start with the player
   %this.camera.setTransform(%player.getEyeTransform());

   // Give the client control of the player
   %this.player = %player;
   %this.setControlObject(%player);
}


//-----------------------------------------------------------------------------

function pickSpawnPoint() 
{
   // Pick the first object in drop point group and use it's
   // location as a spawn point.
   %group = nameToID("MissionGroup/PlayerDropPoints");
   if (%group != -1 && %group.getCount() != 0)
      return %group.getObject(0).getTransform();

   // If no object was found, return a point near the center of the world
   error("Missing spawn point object and/or mission group " @ %groupName);
   return "0 0 300 1 0 0 0";
}

Schedule(3000, 0, "CreateBots");
